from PIL import Image
import glob
import numpy as np
import sys,os,re

datads = glob.glob("omniglot-py/images_background/*/*/")
xs = []
for datadidx,datad in enumerate(datads):
    fns = glob.glob("%s/*.png"%(datad))
    x = []
    for fn in fns:
        x0 = np.ravel(np.array(Image.open(fn,mode='r').convert('L')))
        x0 = 2.0*(x0/256.0-0.5)
        x.append(x0)
    x = np.array(x)
    xs.append(x)


r_train = 0.6 #ratio of training tasks
r_valid = 0.2 #ratio of validation tasks
I = 10 #number of experiments
minK = 2 #minimun number of classes per task
maxK = 10 #maximum number of classes per task
num_overlap = 50 # number of test tasks

n_cate = len(xs)
n_train = int(n_cate*r_train)
n_valid = int(n_cate*r_valid)

od = "omniglot_tr%sva%sI%sO%s"%(r_train,r_valid,I,num_overlap)
os.makedirs(od,exist_ok=True)
datafn = "%s/data.npz"%(od)
np.savez(datafn,xs=xs)

for i in range(I):
    ofn = "%s/i%s.npz"%(od,i)
    perm = np.random.permutation(n_cate)
    train = perm[:n_train]
    valid = perm[n_train:n_train+n_valid]
    test = perm[n_train+n_valid:]
    cnt = 0
    valids = []
    for j in range(num_overlap):
        tperm = np.random.permutation(len(valid))
        K = np.random.randint(minK,maxK)
        valids.append(valid[tperm[:K]])
    tests = []
    for j in range(num_overlap):
        tperm = np.random.permutation(len(test))
        K = np.random.randint(minK,maxK)
        tests.append(test[tperm[:K]])
    print(ofn)
    np.savez(ofn,datafn=datafn,train=train,valids=valids,tests=tests)

    
    
    
    
